=== modified file 'AUTHORS'
--- AUTHORS	2008-07-15 08:32:54 +0000
+++ AUTHORS	2008-10-30 22:02:01 +0000
@@ -1,5 +1,6 @@
 Brian Aker
 Mark Atwood
+Lee Bieber
 Patrick Galbraith
 Toru Maesaka
 Elliot Murphy

=== modified file 'client/drizzle.cc'
--- client/drizzle.cc	2008-11-01 08:40:42 +0000
+++ client/drizzle.cc	2008-11-02 08:50:37 +0000
@@ -36,6 +36,7 @@
 #include <config.h>
 
 #include <string>
+#include CMATH_H
 
 #include "client_priv.h"
 #include <mystrings/m_ctype.h>
@@ -52,6 +53,10 @@
 
 #include <drizzled/gettext.h>
 
+#if defined(CMATH_NAMESPACE)
+  using namespace CMATH_NAMESPACE;
+#endif
+
 const char *VER= "14.14";
 
 /* Don't try to make a nice table if the data is too big */

=== modified file 'client/drizzleslap.cc'
--- client/drizzleslap.cc	2008-10-30 03:03:26 +0000
+++ client/drizzleslap.cc	2008-11-02 03:17:55 +0000
@@ -84,6 +84,12 @@
 #include <ctype.h>
 #include <string>
 
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
+
 using namespace std;
 
 #ifdef HAVE_SMEM

=== modified file 'configure.ac'
--- configure.ac	2008-11-02 08:47:15 +0000
+++ configure.ac	2008-11-02 08:50:37 +0000
@@ -162,8 +162,6 @@
 AC_SUBST(DOT_FRM_VERSION)
 AC_DEFINE_UNQUOTED([FRM_VER], [$DOT_FRM_VERSION],
                    [Version of .frm files])
-AC_DEFINE_UNQUOTED([FRM_VERSION_TRUE_VARCHAR],[FRM_VER+4],
-                   [Current version of .frm info we're using])
 AC_DEFINE_UNQUOTED([DRIZZLE_CONFIG_NAME],["drizzled"],[Name of server config section])
 
 AC_SUBST(SHARED_LIB_MAJOR_VERSION)
@@ -181,7 +179,6 @@
   isam btree library. eg to big to slow.])
 AC_DEFINE([SC_MAXWIDTH],[256], [Max width of screen (for error messages)])
 AC_DEFINE([FN_LEN],[256	], [Max file name len ])
-AC_DEFINE([FN_HEADLEN],[253], [Max length of filepart of file name ])
 AC_DEFINE([FN_EXTLEN],[20], [Max length of extension (part of FN_LEN) ])
 AC_DEFINE([FN_REFLEN],[512], [Max length of full path-name ])
 AC_DEFINE([FN_EXTCHAR],['.'], [File extension character])
@@ -363,7 +360,7 @@
 test -z "$INSTALL_SCRIPT" && INSTALL_SCRIPT='${INSTALL_PROGRAM}'
 
 # Not critical since the generated file is distributed
-AC_CHECK_PROGS(YACC, ['bison -y -p MYSQL'])
+AC_CHECK_PROGS(YACC, ['bison -y -p DRIZZLE'])
 if test -z "$YACC" && test -d ".bzr"
 then
   AC_MSG_ERROR(["bison is required for Drizzle to build from a bzr branch"])
@@ -956,20 +953,16 @@
 AC_CHECK_HEADERS(fcntl.h float.h fpu_control.h ieeefp.h)
 AC_CHECK_HEADERS(limits.h pwd.h select.h linux/config.h)
 AC_CHECK_HEADERS(sys/fpu.h utime.h sys/utime.h )
-AC_CHECK_HEADERS(synch.h sys/mman.h sys/socket.h netinet/in.h arpa/inet.h)
-AC_CHECK_HEADERS(sys/timeb.h sys/vadvise.h sys/wait.h)
+AC_CHECK_HEADERS(synch.h sys/mman.h sys/socket.h)
 AC_CHECK_HEADERS([curses.h term.h],[],[],
 [[#ifdef HAVE_CURSES_H
 # include <curses.h>
 #endif
 ]])
 AC_CHECK_HEADERS(termio.h termios.h sched.h alloca.h)
-AC_CHECK_HEADERS(sys/ioctl.h malloc.h sys/malloc.h sys/ipc.h sys/shm.h)
-AC_CHECK_HEADERS(sys/prctl.h sys/resource.h sys/param.h port.h ieeefp.h)
+AC_CHECK_HEADERS(sys/prctl.h ieeefp.h)
 AC_CHECK_HEADERS(execinfo.h)
 
-AC_CHECK_HEADERS([xfs/xfs.h])
-
 #--------------------------------------------------------------------
 # Check for system libraries. Adds the library to $LIBS
 # and defines HAVE_LIBM etc
@@ -1007,7 +1000,7 @@
 my_save_LIBS="$LIBS"
 LIBS=""
 AC_CHECK_LIB(dl,dlopen)
-AC_CHECK_FUNCS(dlopen dlerror)
+AC_CHECK_FUNCS(dlopen)
 if test "$ac_cv_func_dlopen" != "yes"
 then
   AC_MSG_ERROR([Drizzle requires dlopen])
@@ -1084,34 +1077,21 @@
 DRIZZLE_TIMESPEC_TS
 # Do we have the tzname variable
 DRIZZLE_TZNAME
-# Do the c++ compiler have a bool type
-DRIZZLE_CXX_BOOL
 AC_CHECK_TYPES([sigset_t, off_t], [], [], [#include <sys/types.h>])
-AC_CHECK_TYPES([size_t], [], [], [#include <stdio.h>])
 AC_CHECK_TYPES([uint, ulong])
 
 DRIZZLE_PTHREAD_YIELD
 
 
 dnl Checks for header files.
-AC_CHECK_HEADERS(malloc.h sys/cdefs.h)
+AC_CHECK_HEADERS(malloc.h)
 
 dnl Checks for library functions.
 AC_FUNC_ALLOCA
 AC_PROG_GCC_TRADITIONAL
 AC_TYPE_SIGNAL
-AC_CHECK_FUNCS(re_comp regcomp strdup)
-
-dnl Sun compilers have their own vis.h that is about something
-dnl totally different. So, not to change the libedit source, we
-dnl do some additional checks before we define HAVE_VIS_H.
-AC_CHECK_HEADER(vis.h,
-  [AC_CHECK_FUNC(strvis,
-    [AC_DEFINE([HAVE_VIS_H], [1],[Found vis.h and the strvis() function])])])
-
-AC_CHECK_FUNCS(strlcat strlcpy)
+
 AC_CHECK_FUNCS(issetugid)
-AC_CHECK_FUNCS(getline flockfile)
 
 # from old readline settting:
 
@@ -1120,23 +1100,19 @@
 
 # Already-done: stdlib.h string.h unistd.h termios.h
 AC_CHECK_HEADERS(stdarg.h dirent.h locale.h ndir.h sys/dir.h \
- sys/file.h sys/ndir.h sys/pte.h sys/select.h sys/stream.h \
- sys/mman.h termcap.h termio.h termbits.h asm/termbits.h grp.h \
-paths.h semaphore.h)
+ sys/ndir.h sys/select.h \
+ sys/mman.h termcap.h termio.h asm/termbits.h grp.h \
+ paths.h)
 
 # Already-done: strcasecmp
-AC_CHECK_FUNCS(lstat putenv select setenv setlocale strcoll tcgetattr)
+AC_CHECK_FUNCS(lstat select)
 
 AC_HEADER_STAT
 DRIZZLE_SIGNAL_CHECK
 DRIZZLE_CHECK_GETPW_FUNCS
 DRIZZLE_HAVE_TIOCGWINSZ
-DRIZZLE_HAVE_FIONREAD
 DRIZZLE_HAVE_TIOCSTAT
-DRIZZLE_STRUCT_DIRENT_D_INO
-DRIZZLE_STRUCT_DIRENT_D_NAMLEN
 DRIZZLE_TYPE_SIGHANDLER
-DRIZZLE_CHECK_MULTIBYTE
 if test "$with_named_curses" = "no"
 then
   DRIZZLE_CHECK_LIB_TERMCAP
@@ -1145,19 +1121,6 @@
 fi
 AC_SUBST(TERMCAP_LIBS)
 
-# Check if the termcap function 'tgoto' is already declared in
-# system header files or if it need to be declared locally
-AC_CHECK_DECLS(tgoto,,,[
-#ifdef HAVE_CURSES_H
-# include <curses.h>
-#elif HAVE_NCURSES_H
-# include <ncurses.h>
-#endif
-#ifdef HAVE_TERM_H
-# include <term.h>
-#endif
-])
-
 # End of readline/libedit stuff
 #########################################################################
 
@@ -1187,25 +1150,24 @@
 
 AC_CONFIG_LIBOBJ_DIR([mystrings])
 
-AC_CHECK_FUNCS(bsearch \
+AC_CHECK_FUNCS( \
   cuserid fchmod \
-  fdatasync finite fpresetsticky fpsetmask fsync ftruncate \
+  fdatasync fpresetsticky fpsetmask fsync \
   getcwd getpassphrase getpwnam \
   getpwuid getrlimit getrusage getwd index initgroups isnan \
   localtime_r gethrtime gmtime_r \
-  locking longjmp lrand48 madvise mallinfo \
-  memmove \
-  mkstemp mlockall perror poll pread pthread_attr_create mmap mmap64 \
+  madvise \
+  mkstemp mlockall poll pread pthread_attr_create mmap mmap64 \
   pthread_attr_getstacksize pthread_attr_setprio pthread_attr_setschedparam \
   pthread_attr_setstacksize pthread_condattr_create pthread_getsequence_np \
   pthread_key_delete pthread_rwlock_rdlock pthread_setprio \
   pthread_setprio_np pthread_setschedparam pthread_sigmask readlink \
   realpath rename rwlock_init setupterm \
-  shmget shmat shmdt shmctl sigaction sigemptyset sigaddset \
-  sighold sigset sigthreadmask port_create sleep \
-  snprintf socket strcasecmp strerror strsignal strpbrk \
-  tell tempnam vidattr \
-  posix_fallocate backtrace backtrace_symbols backtrace_symbols_fd)
+  sigaction \
+  sigthreadmask \
+  snprintf strpbrk \
+  tell tempnam \
+  backtrace backtrace_symbols backtrace_symbols_fd)
 
 AC_LANG_PUSH(C++)
 # Test whether madvise() is declared in C++ code -- it is not on some
@@ -1221,31 +1183,6 @@
 
 AM_CONDITIONAL(BUILD_THR_RWLOCK,[test "$ac_cv_func_rwlock_init" -a "$ac_cv_funn_pthread_rwlock_rdlock"])
 
-# Check that isinf() is available in math.h and can be used in both C and C++
-# code
-AC_MSG_CHECKING(for isinf in math.h)
-AC_LINK_IFELSE([AC_LANG_PROGRAM([[#include <math.h>]], [[
-    float f = 0.0; 
-    int r = isinf(f); 
-    return r;
-  ]])],[
-    AC_MSG_RESULT(yes)
-    AC_MSG_CHECKING(whether isinf() can be used in C++ code)
-    AC_LANG_PUSH([C++])
-    AC_LINK_IFELSE([AC_LANG_PROGRAM([[#include <math.h>]], [[
-      float f = 0.0;
-      int r = isinf(f);
-      return r;
-    ]])],[
-      AC_MSG_RESULT(yes)
-      AC_DEFINE(HAVE_ISINF, [1], [isinf() macro or function])
-    ],[
-      AC_MSG_RESULT(no)
-    ])
-    AC_LANG_POP([])
-  ],[
-  AC_MSG_RESULT(no)])
-
 
 CFLAGS="$ORG_CFLAGS"
 
@@ -1368,20 +1305,6 @@
   AC_DEFINE([HAVE_PTHREAD_ATTR_SETSCOPE], [1], [pthread_attr_setscope])
 fi
 
-# Check for bad includes
-AC_MSG_CHECKING("can netinet files be included")
-AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <sys/types.h>
-#include <sys/socket.h>
-#include <netinet/in_systm.h>
-#include <netinet/in.h>
-#include <netinet/ip.h>
-#include <netinet/tcp.h>]], [[ printf("1\n"); ]])],[netinet_inc=yes],[netinet_inc=no])
-if test "$netinet_inc" = "no"
-then
-  AC_DEFINE([HAVE_BROKEN_NETINET_INCLUDES], [1], [Can netinet be included])
-fi
-AC_MSG_RESULT("$netinet_inc")
-
 AC_LANG_PUSH([C++])
 AC_CHECK_HEADERS(cxxabi.h)
 AC_CACHE_CHECK([checking for abi::__cxa_demangle], mysql_cv_cxa_demangle,

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2008-10-30 03:03:26 +0000
+++ drizzled/drizzled.cc	2008-10-30 21:37:46 +0000
@@ -245,8 +245,6 @@
 static char compiled_default_collation_name[]= DRIZZLE_DEFAULT_COLLATION_NAME;
 static I_List<Session> thread_cache;
 
-static pthread_cond_t COND_thread_cache, COND_flush_thread_cache;
-
 /* Global variables */
 
 bool opt_bin_log;
@@ -458,7 +456,8 @@
 uint32_t report_port= DRIZZLE_PORT;
 uint32_t master_retry_count= 0;
 char *master_info_file;
-char *relay_log_info_file, *report_user, *report_password, *report_host;
+char *relay_log_info_file;
+char *report_host;
 char *opt_relay_logname = 0, *opt_relaylog_index_name=0;
 char *opt_logname;
 
@@ -923,8 +922,6 @@
   (void) pthread_cond_destroy(&COND_thread_count);
   (void) pthread_cond_destroy(&COND_refresh);
   (void) pthread_cond_destroy(&COND_global_read_lock);
-  (void) pthread_cond_destroy(&COND_thread_cache);
-  (void) pthread_cond_destroy(&COND_flush_thread_cache);
 }
 
 
@@ -2140,8 +2137,6 @@
   (void) pthread_cond_init(&COND_thread_count,NULL);
   (void) pthread_cond_init(&COND_refresh,NULL);
   (void) pthread_cond_init(&COND_global_read_lock,NULL);
-  (void) pthread_cond_init(&COND_thread_cache,NULL);
-  (void) pthread_cond_init(&COND_flush_thread_cache,NULL);
 
   /* Parameter for threads created for connections */
   (void) pthread_attr_init(&connection_attrib);
@@ -3266,16 +3261,6 @@
       "the slave from the master or other hosts."),
    (char**) &report_host, (char**) &report_host, 0, GET_STR, REQUIRED_ARG, 0, 0,
    0, 0, 0, 0},
-  {"report-password", OPT_REPORT_PASSWORD, "Undocumented.",
-   (char**) &report_password, (char**) &report_password, 0, GET_STR,
-   REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
-  {"report-port", OPT_REPORT_PORT,
-   N_("Port for connecting to slave reported to the master during slave "
-      "registration. Set it only if the slave is listening on a non-default "
-      "port or if you have a special tunnel from the master or other clients "
-      "to the slave. If not sure, leave this option unset."),
-   (char**) &report_port, (char**) &report_port, 0, GET_UINT, REQUIRED_ARG,
-   DRIZZLE_PORT, 0, 0, 0, 0, 0},
   {"safe-mode", OPT_SAFE,
    N_("Skip some optimize stages (for testing)."),
    0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0},
@@ -4174,7 +4159,7 @@
   /* Replication parameters */
   master_info_file= (char*) "master.info",
     relay_log_info_file= (char*) "relay-log.info";
-  report_user= report_password = report_host= 0;	/* TO BE DELETED */
+  report_host= 0;	/* TO BE DELETED */
   opt_relay_logname= opt_relaylog_index_name= 0;
 
   /* Variables in libraries */

=== modified file 'drizzled/field/date.cc'
--- drizzled/field/date.cc	2008-10-23 03:41:40 +0000
+++ drizzled/field/date.cc	2008-11-02 03:17:55 +0000
@@ -22,6 +22,11 @@
 #include <drizzled/server_includes.h>
 #include <drizzled/field/date.h>
 #include <drizzled/error.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 /****************************************************************************
 ** The new date type

=== modified file 'drizzled/field/datetime.cc'
--- drizzled/field/datetime.cc	2008-10-23 03:41:40 +0000
+++ drizzled/field/datetime.cc	2008-11-02 03:17:55 +0000
@@ -22,6 +22,11 @@
 #include <drizzled/server_includes.h>
 #include <drizzled/field/datetime.h>
 #include <drizzled/error.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 /****************************************************************************
 ** datetime type

=== modified file 'drizzled/field/double.cc'
--- drizzled/field/double.cc	2008-10-23 02:48:56 +0000
+++ drizzled/field/double.cc	2008-11-02 03:17:55 +0000
@@ -22,6 +22,11 @@
 #include <drizzled/server_includes.h>
 #include <drizzled/field/double.h>
 #include <drizzled/error.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 /****************************************************************************
   double precision floating point numbers

=== modified file 'drizzled/field/int64_t.cc'
--- drizzled/field/int64_t.cc	2008-10-23 03:41:40 +0000
+++ drizzled/field/int64_t.cc	2008-11-02 03:17:55 +0000
@@ -22,6 +22,11 @@
 #include <drizzled/server_includes.h>
 #include <drizzled/field/int64_t.h>
 #include <drizzled/error.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 /****************************************************************************
  Field type int64_t int (8 bytes)

=== modified file 'drizzled/field/long.cc'
--- drizzled/field/long.cc	2008-10-23 03:41:40 +0000
+++ drizzled/field/long.cc	2008-11-02 03:17:55 +0000
@@ -22,6 +22,11 @@
 #include <drizzled/server_includes.h>
 #include <drizzled/field/long.h>
 #include <drizzled/error.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 /****************************************************************************
 ** long int

=== modified file 'drizzled/field/real.cc'
--- drizzled/field/real.cc	2008-11-02 08:47:15 +0000
+++ drizzled/field/real.cc	2008-11-02 08:50:37 +0000
@@ -21,10 +21,11 @@
 #include <drizzled/server_includes.h>
 #include <drizzled/field/real.h>
 #include <drizzled/error.h>
-#include <ieeefp.h>
 #include CMATH_H
 
-using namespace std;
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 /*
   Floating-point numbers

=== modified file 'drizzled/field/timestamp.cc'
--- drizzled/field/timestamp.cc	2008-10-28 10:10:54 +0000
+++ drizzled/field/timestamp.cc	2008-11-02 03:17:55 +0000
@@ -23,6 +23,11 @@
 #include <drizzled/field/timestamp.h>
 #include <drizzled/error.h>
 #include <drizzled/tztime.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 /**
   TIMESTAMP type holds datetime values in range from 1970-01-01 00:00:01 UTC to 

=== modified file 'drizzled/field/timetype.cc'
--- drizzled/field/timetype.cc	2008-10-23 02:48:56 +0000
+++ drizzled/field/timetype.cc	2008-11-02 03:17:55 +0000
@@ -22,6 +22,12 @@
 #include <drizzled/server_includes.h>
 #include <drizzled/field/timetype.h>
 #include <drizzled/error.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
+
 
 /****************************************************************************
 ** time type

=== modified file 'drizzled/functions/Makefile.am'
--- drizzled/functions/Makefile.am	2008-10-29 02:36:17 +0000
+++ drizzled/functions/Makefile.am	2008-10-30 21:40:56 +0000
@@ -67,14 +67,17 @@
 			  real.cc \
 			  round.cc \
 			  row_count.cc \
+			  set_user_var.cc \
 			  shift.cc \
 			  sign.cc \
 			  signed.cc \
 			  sin.cc \
 			  sqrt.cc \
 			  tan.cc \
+			  update_hash.cc \
 			  units.cc \
-			  unsigned.cc
+			  unsigned.cc \
+			  user_var_as_out_param.cc
 
 noinst_HEADERS = abs.h \
 		 acos.h \
@@ -128,12 +131,14 @@
 		 rollup_const.h \
 		 round.h \
 		 row_count.h \
+		 set_user_var.h \
 		 sign.h \
 		 signed.h \
 		 sin.h \
 		 sqrt.h \
 		 tan.h \
-		 unsigned.h
+		 unsigned.h \
+		 user_var_as_out_param.h
 	
 
 DEFS= -DDRIZZLE_SERVER @DEFS@

=== modified file 'drizzled/functions/abs.cc'
--- drizzled/functions/abs.cc	2008-10-11 02:15:37 +0000
+++ drizzled/functions/abs.cc	2008-11-02 03:17:55 +0000
@@ -20,6 +20,12 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/abs.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
+
 
 double Item_func_abs::real_op()
 {

=== modified file 'drizzled/functions/acos.cc'
--- drizzled/functions/acos.cc	2008-10-13 00:41:41 +0000
+++ drizzled/functions/acos.cc	2008-11-02 03:17:55 +0000
@@ -20,6 +20,12 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/acos.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
+
 
 double Item_func_acos::val_real()
 {

=== modified file 'drizzled/functions/asin.cc'
--- drizzled/functions/asin.cc	2008-10-13 00:41:41 +0000
+++ drizzled/functions/asin.cc	2008-11-02 03:17:55 +0000
@@ -20,6 +20,12 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/asin.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
+
 
 double Item_func_asin::val_real()
 { 

=== modified file 'drizzled/functions/atan.cc'
--- drizzled/functions/atan.cc	2008-10-13 00:41:41 +0000
+++ drizzled/functions/atan.cc	2008-11-02 03:17:55 +0000
@@ -20,6 +20,12 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/atan.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
+
 
 double Item_func_atan::val_real()
 {

=== modified file 'drizzled/functions/ceiling.cc'
--- drizzled/functions/ceiling.cc	2008-10-13 03:50:26 +0000
+++ drizzled/functions/ceiling.cc	2008-11-02 03:17:55 +0000
@@ -20,6 +20,12 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/ceiling.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
+
 
 int64_t Item_func_ceiling::int_op()
 {

=== modified file 'drizzled/functions/cos.cc'
--- drizzled/functions/cos.cc	2008-10-13 03:50:26 +0000
+++ drizzled/functions/cos.cc	2008-11-02 03:17:55 +0000
@@ -20,6 +20,12 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/cos.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
+
 
 double Item_func_cos::val_real()
 {

=== modified file 'drizzled/functions/exp.cc'
--- drizzled/functions/exp.cc	2008-10-11 02:15:37 +0000
+++ drizzled/functions/exp.cc	2008-11-02 03:17:55 +0000
@@ -21,6 +21,12 @@
 #include CSTDINT_H
 #include <drizzled/item_func.h>
 #include <drizzled/functions/exp.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
+
 
 double Item_func_exp::val_real()
 {

=== modified file 'drizzled/functions/floor.cc'
--- drizzled/functions/floor.cc	2008-10-13 21:02:40 +0000
+++ drizzled/functions/floor.cc	2008-11-02 03:17:55 +0000
@@ -20,6 +20,12 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/floor.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
+
 
 int64_t Item_func_floor::int_op()
 {

=== modified file 'drizzled/functions/func.cc'
--- drizzled/functions/func.cc	2008-10-25 04:31:54 +0000
+++ drizzled/functions/func.cc	2008-11-02 03:17:55 +0000
@@ -27,6 +27,12 @@
 #include <drizzled/sql_list.h>
 
 #include <drizzled/functions/int.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
+
 
 
 void Item_func::set_arguments(List<Item> &list)

=== modified file 'drizzled/functions/ln.cc'
--- drizzled/functions/ln.cc	2008-10-11 02:15:37 +0000
+++ drizzled/functions/ln.cc	2008-11-02 03:17:55 +0000
@@ -20,6 +20,12 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/ln.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
+
 
 /** Gateway to natural LOG function. */
 double Item_func_ln::val_real()

=== modified file 'drizzled/functions/log.cc'
--- drizzled/functions/log.cc	2008-10-11 02:15:37 +0000
+++ drizzled/functions/log.cc	2008-11-02 03:17:55 +0000
@@ -20,6 +20,11 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/log.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 /**
   Extended but so slower LOG function.

=== modified file 'drizzled/functions/mod.cc'
--- drizzled/functions/mod.cc	2008-10-10 21:17:54 +0000
+++ drizzled/functions/mod.cc	2008-11-02 03:17:55 +0000
@@ -20,6 +20,11 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/mod.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 int64_t Item_func_mod::int_op()
 {

=== modified file 'drizzled/functions/numhybrid.cc'
--- drizzled/functions/numhybrid.cc	2008-10-08 23:49:26 +0000
+++ drizzled/functions/numhybrid.cc	2008-11-02 03:17:55 +0000
@@ -23,6 +23,11 @@
 #include <cassert>
 
 #include <drizzled/functions/numhybrid.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 void Item_func_numhybrid::fix_num_length_and_dec()
 {}

=== modified file 'drizzled/functions/pow.cc'
--- drizzled/functions/pow.cc	2008-10-13 00:41:41 +0000
+++ drizzled/functions/pow.cc	2008-11-02 03:17:55 +0000
@@ -20,6 +20,11 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/pow.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 double Item_func_pow::val_real()
 {

=== modified file 'drizzled/functions/real.cc'
--- drizzled/functions/real.cc	2008-11-02 08:47:15 +0000
+++ drizzled/functions/real.cc	2008-11-02 08:50:37 +0000
@@ -18,17 +18,16 @@
  */
 
 #include <drizzled/server_includes.h>
+#include <drizzled/functions/real.h>
 
 #include CSTDINT_H
+#include <cassert>
 #include CMATH_H
-#include <cassert>
 
-#if defined(CMATH_NAMESPACE) && CMATH_NAMESPACE
-using CMATH_NAMESPACE;
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
 #endif
 
-#include <drizzled/functions/real.h>
-
 String *Item_real_func::val_str(String *str)
 {
   assert(fixed == 1);
@@ -50,4 +49,15 @@
   return decimal_value;
 }
 
+int64_t Item_real_func::val_int()
+{
+  assert(fixed == 1);
+  return (int64_t) rint(val_real());
+}
+
+void Item_real_func::fix_length_and_dec()
+{
+  decimals= NOT_FIXED_DEC;
+  max_length= float_length(decimals);
+}
 

=== modified file 'drizzled/functions/real.h'
--- drizzled/functions/real.h	2008-10-08 23:49:26 +0000
+++ drizzled/functions/real.h	2008-11-02 03:17:55 +0000
@@ -31,11 +31,9 @@
   Item_real_func(List<Item> &list) :Item_func(list) {}
   String *val_str(String*str);
   my_decimal *val_decimal(my_decimal *decimal_value);
-  int64_t val_int()
-    { assert(fixed == 1); return (int64_t) rint(val_real()); }
+  int64_t val_int();
   enum Item_result result_type () const { return REAL_RESULT; }
-  void fix_length_and_dec()
-  { decimals= NOT_FIXED_DEC; max_length= float_length(decimals); }
+  void fix_length_and_dec();
 };
 
 #endif /* DRIZZLED_FUNCTIONS_REAL_H */

=== modified file 'drizzled/functions/round.cc'
--- drizzled/functions/round.cc	2008-10-24 21:49:14 +0000
+++ drizzled/functions/round.cc	2008-11-02 03:17:55 +0000
@@ -17,10 +17,15 @@
  *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  */
 
-using namespace std;
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/round.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
+using namespace std;
 
 void Item_func_round::fix_length_and_dec()
 {

=== added file 'drizzled/functions/set_user_var.cc'
--- drizzled/functions/set_user_var.cc	1970-01-01 00:00:00 +0000
+++ drizzled/functions/set_user_var.cc	2008-10-30 21:40:56 +0000
@@ -0,0 +1,464 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include CSTDINT_H
+#include <drizzled/functions/set_user_var.h>
+
+/*
+  When a user variable is updated (in a SET command or a query like
+  SELECT @a:= ).
+*/
+
+bool Item_func_set_user_var::fix_fields(Session *session, Item **ref)
+{
+  assert(fixed == 0);
+  /* fix_fields will call Item_func_set_user_var::fix_length_and_dec */
+  if (Item_func::fix_fields(session, ref) ||
+      !(entry= get_variable(&session->user_vars, name, 1)))
+    return true;
+  /*
+     Remember the last query which updated it, this way a query can later know
+     if this variable is a constant item in the query (it is if update_query_id
+     is different from query_id).
+  */
+  entry->update_query_id= session->query_id;
+  /*
+    As it is wrong and confusing to associate any
+    character set with NULL, @a should be latin2
+    after this query sequence:
+
+      SET @a=_latin2'string';
+      SET @a=NULL;
+
+    I.e. the second query should not change the charset
+    to the current default value, but should keep the
+    original value assigned during the first query.
+    In order to do it, we don't copy charset
+    from the argument if the argument is NULL
+    and the variable has previously been initialized.
+  */
+  null_item= (args[0]->type() == NULL_ITEM);
+  if (!entry->collation.collation || !null_item)
+    entry->collation.set(args[0]->collation.collation, DERIVATION_IMPLICIT);
+  collation.set(entry->collation.collation, DERIVATION_IMPLICIT);
+  cached_result_type= args[0]->result_type();
+  return false;
+}
+
+void
+Item_func_set_user_var::fix_length_and_dec()
+{
+  maybe_null=args[0]->maybe_null;
+  max_length=args[0]->max_length;
+  decimals=args[0]->decimals;
+  collation.set(args[0]->collation.collation, DERIVATION_IMPLICIT);
+}
+
+/*
+  Mark field in read_map
+
+  NOTES
+    This is used by filesort to register used fields in a a temporary
+    column read set or to register used fields in a view
+*/
+
+bool Item_func_set_user_var::register_field_in_read_map(unsigned char *arg)
+{
+  if (result_field)
+  {
+    Table *table= (Table *) arg;
+    if (result_field->table == table || !table)
+      bitmap_set_bit(result_field->table->read_set, result_field->field_index);
+    if (result_field->vcol_info && result_field->vcol_info->expr_item)
+      return result_field->vcol_info->
+               expr_item->walk(&Item::register_field_in_read_map, 1, arg);
+  }
+  return 0;
+}
+
+/*
+  Mark field in bitmap supplied as *arg
+
+*/
+
+bool Item_func_set_user_var::register_field_in_bitmap(unsigned char *arg)
+{
+  MY_BITMAP *bitmap = (MY_BITMAP *) arg;
+  assert(bitmap);
+  if (result_field)
+  {
+    bitmap_set_bit(bitmap, result_field->field_index);
+  }
+  return 0;
+}
+
+bool
+Item_func_set_user_var::update_hash(void *ptr, uint32_t length,
+                                    Item_result res_type,
+                                    const CHARSET_INFO * const cs, Derivation dv,
+                                    bool unsigned_arg)
+{
+  /*
+    If we set a variable explicitely to NULL then keep the old
+    result type of the variable
+  */
+  if ((null_value= args[0]->null_value) && null_item)
+    res_type= entry->type;                      // Don't change type of item
+  if (::update_hash(entry, (null_value= args[0]->null_value),
+                    ptr, length, res_type, cs, dv, unsigned_arg))
+  {
+    null_value= 1;
+    return 1;
+  }
+  return 0;
+}
+
+/**
+  This functions is invoked on SET \@variable or
+  \@variable:= expression.
+
+  Evaluate (and check expression), store results.
+
+  @note
+    For now it always return OK. All problem with value evaluating
+    will be caught by session->is_error() check in sql_set_variables().
+
+  @retval
+    false OK.
+*/
+
+bool
+Item_func_set_user_var::check(bool use_result_field)
+{
+  if (use_result_field && !result_field)
+    use_result_field= false;
+
+  switch (cached_result_type) {
+  case REAL_RESULT:
+  {
+    save_result.vreal= use_result_field ? result_field->val_real() :
+                        args[0]->val_real();
+    break;
+  }
+  case INT_RESULT:
+  {
+    save_result.vint= use_result_field ? result_field->val_int() :
+                       args[0]->val_int();
+    unsigned_flag= use_result_field ? ((Field_num*)result_field)->unsigned_flag:
+                    args[0]->unsigned_flag;
+    break;
+  }
+  case STRING_RESULT:
+  {
+    save_result.vstr= use_result_field ? result_field->val_str(&value) :
+                       args[0]->val_str(&value);
+    break;
+  }
+  case DECIMAL_RESULT:
+  {
+    save_result.vdec= use_result_field ?
+                       result_field->val_decimal(&decimal_buff) :
+                       args[0]->val_decimal(&decimal_buff);
+    break;
+  }
+  case ROW_RESULT:
+  default:
+    // This case should never be chosen
+    assert(0);
+    break;
+  }
+  return(false);
+}
+
+/**
+  This functions is invoked on
+  SET \@variable or \@variable:= expression.
+
+  @note
+    We have to store the expression as such in the variable, independent of
+    the value method used by the user
+
+  @retval
+    0   OK
+  @retval
+    1   EOM Error
+
+*/
+
+bool
+Item_func_set_user_var::update()
+{
+  bool res= false;
+
+  switch (cached_result_type) {
+  case REAL_RESULT:
+  {
+    res= update_hash((void*) &save_result.vreal,sizeof(save_result.vreal),
+                     REAL_RESULT, &my_charset_bin, DERIVATION_IMPLICIT, 0);
+    break;
+  }
+  case INT_RESULT:
+  {
+    res= update_hash((void*) &save_result.vint, sizeof(save_result.vint),
+                     INT_RESULT, &my_charset_bin, DERIVATION_IMPLICIT,
+                     unsigned_flag);
+    break;
+  }
+  case STRING_RESULT:
+  {
+    if (!save_result.vstr)                                      // Null value
+      res= update_hash((void*) 0, 0, STRING_RESULT, &my_charset_bin,
+                       DERIVATION_IMPLICIT, 0);
+    else
+      res= update_hash((void*) save_result.vstr->ptr(),
+                       save_result.vstr->length(), STRING_RESULT,
+                       save_result.vstr->charset(),
+                       DERIVATION_IMPLICIT, 0);
+    break;
+  }
+  case DECIMAL_RESULT:
+  {
+    if (!save_result.vdec)                                      // Null value
+      res= update_hash((void*) 0, 0, DECIMAL_RESULT, &my_charset_bin,
+                       DERIVATION_IMPLICIT, 0);
+    else
+      res= update_hash((void*) save_result.vdec,
+                       sizeof(my_decimal), DECIMAL_RESULT,
+                       &my_charset_bin, DERIVATION_IMPLICIT, 0);
+    break;
+  }
+  case ROW_RESULT:
+  default:
+    // This case should never be chosen
+    assert(0);
+    break;
+  }
+  return(res);
+}
+
+double Item_func_set_user_var::val_real()
+{
+  assert(fixed == 1);
+  check(0);
+  update();                                     // Store expression
+  return entry->val_real(&null_value);
+}
+
+int64_t Item_func_set_user_var::val_int()
+{
+  assert(fixed == 1);
+  check(0);
+  update();                                     // Store expression
+  return entry->val_int(&null_value);
+}
+
+String *Item_func_set_user_var::val_str(String *str)
+{
+  assert(fixed == 1);
+  check(0);
+  update();                                     // Store expression
+  return entry->val_str(&null_value, str, decimals);
+}
+
+
+my_decimal *Item_func_set_user_var::val_decimal(my_decimal *val)
+{
+  assert(fixed == 1);
+  check(0);
+  update();                                     // Store expression
+  return entry->val_decimal(&null_value, val);
+}
+
+double Item_func_set_user_var::val_result()
+{
+  assert(fixed == 1);
+  check(true);
+  update();                                     // Store expression
+  return entry->val_real(&null_value);
+}
+
+int64_t Item_func_set_user_var::val_int_result()
+{
+  assert(fixed == 1);
+  check(true);
+  update();                                     // Store expression
+  return entry->val_int(&null_value);
+}
+
+String *Item_func_set_user_var::str_result(String *str)
+{
+  assert(fixed == 1);
+  check(true);
+  update();                                     // Store expression
+  return entry->val_str(&null_value, str, decimals);
+}
+
+
+my_decimal *Item_func_set_user_var::val_decimal_result(my_decimal *val)
+{
+  assert(fixed == 1);
+  check(true);
+  update();                                     // Store expression
+  return entry->val_decimal(&null_value, val);
+}
+
+void Item_func_set_user_var::print(String *str, enum_query_type query_type)
+{
+  str->append(STRING_WITH_LEN("(@"));
+  str->append(name.str, name.length);
+  str->append(STRING_WITH_LEN(":="));
+  args[0]->print(str, query_type);
+  str->append(')');
+}
+
+
+void Item_func_set_user_var::print_as_stmt(String *str,
+                                           enum_query_type query_type)
+{
+  str->append(STRING_WITH_LEN("set @"));
+  str->append(name.str, name.length);
+  str->append(STRING_WITH_LEN(":="));
+  args[0]->print(str, query_type);
+  str->append(')');
+}
+
+bool Item_func_set_user_var::send(Protocol *protocol, String *str_arg)
+{
+  if (result_field)
+  {
+    check(1);
+    update();
+    return protocol->store(result_field);
+  }
+  return Item::send(protocol, str_arg);
+}
+
+void Item_func_set_user_var::make_field(Send_field *tmp_field)
+{
+  if (result_field)
+  {
+    result_field->make_field(tmp_field);
+    assert(tmp_field->table_name != 0);
+    if (Item::name)
+      tmp_field->col_name=Item::name;               // Use user supplied name
+  }
+  else
+    Item::make_field(tmp_field);
+}
+
+/*
+  Save the value of a user variable into a field
+
+  SYNOPSIS
+    save_in_field()
+      field           target field to save the value to
+      no_conversion   flag indicating whether conversions are allowed
+
+  DESCRIPTION
+    Save the function value into a field and update the user variable
+    accordingly. If a result field is defined and the target field doesn't
+    coincide with it then the value from the result field will be used as
+    the new value of the user variable.
+
+    The reason to have this method rather than simply using the result
+    field in the val_xxx() methods is that the value from the result field
+    not always can be used when the result field is defined.
+    Let's consider the following cases:
+    1) when filling a tmp table the result field is defined but the value of it
+    is undefined because it has to be produced yet. Thus we can't use it.
+    2) on execution of an INSERT ... SELECT statement the save_in_field()
+    function will be called to fill the data in the new record. If the SELECT
+    part uses a tmp table then the result field is defined and should be
+    used in order to get the correct result.
+
+    The difference between the SET_USER_VAR function and regular functions
+    like CONCAT is that the Item_func objects for the regular functions are
+    replaced by Item_field objects after the values of these functions have
+    been stored in a tmp table. Yet an object of the Item_field class cannot
+    be used to update a user variable.
+    Due to this we have to handle the result field in a special way here and
+    in the Item_func_set_user_var::send() function.
+
+  RETURN VALUES
+    false       Ok
+    true        Error
+*/
+
+int Item_func_set_user_var::save_in_field(Field *field, bool no_conversions,
+                                          bool can_use_result_field)
+{
+  bool use_result_field= (!can_use_result_field ? 0 :
+                          (result_field && result_field != field));
+  int error;
+
+  /* Update the value of the user variable */
+  check(use_result_field);
+  update();
+
+  if (result_type() == STRING_RESULT ||
+      (result_type() == REAL_RESULT && field->result_type() == STRING_RESULT))
+  {
+    String *result;
+    const CHARSET_INFO * const cs= collation.collation;
+    char buff[MAX_FIELD_WIDTH];         // Alloc buffer for small columns
+    str_value.set_quick(buff, sizeof(buff), cs);
+    result= entry->val_str(&null_value, &str_value, decimals);
+
+    if (null_value)
+    {
+      str_value.set_quick(0, 0, cs);
+      return set_field_to_null_with_conversions(field, no_conversions);
+    }
+
+    /* NOTE: If null_value == false, "result" must be not NULL.  */
+
+    field->set_notnull();
+    error=field->store(result->ptr(),result->length(),cs);
+    str_value.set_quick(0, 0, cs);
+  }
+  else if (result_type() == REAL_RESULT)
+  {
+    double nr= entry->val_real(&null_value);
+    if (null_value)
+      return set_field_to_null(field);
+    field->set_notnull();
+    error=field->store(nr);
+  }
+  else if (result_type() == DECIMAL_RESULT)
+  {
+    my_decimal decimal_value;
+    my_decimal *val= entry->val_decimal(&null_value, &decimal_value);
+    if (null_value)
+      return set_field_to_null(field);
+    field->set_notnull();
+    error=field->store_decimal(val);
+  }
+  else
+  {
+    int64_t nr= entry->val_int(&null_value);
+    if (null_value)
+      return set_field_to_null_with_conversions(field, no_conversions);
+    field->set_notnull();
+    error=field->store(nr, unsigned_flag);
+  }
+  return error;
+}
+
+

=== added file 'drizzled/functions/set_user_var.h'
--- drizzled/functions/set_user_var.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/set_user_var.h	2008-10-30 21:40:56 +0000
@@ -0,0 +1,82 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_SET_USER_VAR_H
+#define DRIZZLED_FUNCTIONS_SET_USER_VAR_H
+
+#include <drizzled/functions/func.h> 
+
+/* Handling of user definable variables */
+
+class user_var_entry;
+
+class Item_func_set_user_var :public Item_func
+{
+  enum Item_result cached_result_type;
+  user_var_entry *entry;
+  char buffer[MAX_FIELD_WIDTH];
+  String value;
+  my_decimal decimal_buff;
+  bool null_item;
+  union
+  {
+    int64_t vint;
+    double vreal;
+    String *vstr;
+    my_decimal *vdec;
+  } save_result;
+
+public:
+  LEX_STRING name; // keep it public
+  Item_func_set_user_var(LEX_STRING a,Item *b)
+    :Item_func(b), cached_result_type(INT_RESULT), name(a)
+  {}
+  enum Functype functype() const { return SUSERVAR_FUNC; }
+  double val_real();
+  int64_t val_int();
+  String *val_str(String *str);
+  my_decimal *val_decimal(my_decimal *);
+  double val_result();
+  int64_t val_int_result();
+  String *str_result(String *str);
+  my_decimal *val_decimal_result(my_decimal *);
+  bool update_hash(void *ptr, uint32_t length, enum Item_result type,
+  		   const CHARSET_INFO * const cs, Derivation dv, bool unsigned_arg);
+  bool send(Protocol *protocol, String *str_arg);
+  void make_field(Send_field *tmp_field);
+  bool check(bool use_result_field);
+  bool update();
+  enum Item_result result_type () const { return cached_result_type; }
+  bool fix_fields(Session *session, Item **ref);
+  void fix_length_and_dec();
+  virtual void print(String *str, enum_query_type query_type);
+  void print_as_stmt(String *str, enum_query_type query_type);
+  const char *func_name() const { return "set_user_var"; }
+  int save_in_field(Field *field, bool no_conversions,
+                    bool can_use_result_field);
+  int save_in_field(Field *field, bool no_conversions)
+  {
+    return save_in_field(field, no_conversions, 1);
+  }
+  void save_org_in_field(Field *field) { (void)save_in_field(field, 1, 0); }
+  bool register_field_in_read_map(unsigned char *arg);
+  bool register_field_in_bitmap(unsigned char *arg);
+};
+
+#endif /* DRIZZLED_FUNCTIONS_SET_USER_VAR_H */

=== modified file 'drizzled/functions/sin.cc'
--- drizzled/functions/sin.cc	2008-10-13 03:50:26 +0000
+++ drizzled/functions/sin.cc	2008-11-02 03:17:55 +0000
@@ -20,6 +20,11 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/sin.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 double Item_func_sin::val_real()
 {

=== modified file 'drizzled/functions/sqrt.cc'
--- drizzled/functions/sqrt.cc	2008-10-13 00:41:41 +0000
+++ drizzled/functions/sqrt.cc	2008-11-02 03:17:55 +0000
@@ -20,6 +20,11 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/sqrt.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 double Item_func_sqrt::val_real()
 {

=== modified file 'drizzled/functions/tan.cc'
--- drizzled/functions/tan.cc	2008-10-13 03:50:26 +0000
+++ drizzled/functions/tan.cc	2008-11-02 03:17:55 +0000
@@ -20,6 +20,11 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/tan.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 double Item_func_tan::val_real()
 { 

=== added file 'drizzled/functions/update_hash.cc'
--- drizzled/functions/update_hash.cc	1970-01-01 00:00:00 +0000
+++ drizzled/functions/update_hash.cc	2008-10-30 21:40:56 +0000
@@ -0,0 +1,103 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include CSTDINT_H
+#include <drizzled/functions/update_hash.h>
+
+/**
+  Set value to user variable.
+
+  @param entry          pointer to structure representing variable
+  @param set_null       should we set NULL value ?
+  @param ptr            pointer to buffer with new value
+  @param length         length of new value
+  @param type           type of new value
+  @param cs             charset info for new value
+  @param dv             derivation for new value
+  @param unsigned_arg   indiates if a value of type INT_RESULT is unsigned
+
+  @note Sets error and fatal error if allocation fails.
+
+  @retval
+    false   success
+  @retval
+    true    failure
+*/
+
+#define extra_size sizeof(double)
+
+bool
+update_hash(user_var_entry *entry, bool set_null, void *ptr, uint32_t length,
+            Item_result type, const CHARSET_INFO * const cs, Derivation dv,
+            bool unsigned_arg)
+{
+  if (set_null)
+  {
+    char *pos= (char*) entry+ ALIGN_SIZE(sizeof(user_var_entry));
+    if (entry->value && entry->value != pos)
+      free(entry->value);
+    entry->value= 0;
+    entry->length= 0;
+  }
+  else
+  {
+    if (type == STRING_RESULT)
+      length++;					// Store strings with end \0
+    if (length <= extra_size)
+    {
+      /* Save value in value struct */
+      char *pos= (char*) entry+ ALIGN_SIZE(sizeof(user_var_entry));
+      if (entry->value != pos)
+      {
+	if (entry->value)
+	  free(entry->value);
+	entry->value=pos;
+      }
+    }
+    else
+    {
+      /* Allocate variable */
+      if (entry->length != length)
+      {
+	char *pos= (char*) entry+ ALIGN_SIZE(sizeof(user_var_entry));
+	if (entry->value == pos)
+	  entry->value=0;
+        entry->value= (char*) my_realloc(entry->value, length,
+                                         MYF(MY_ALLOW_ZERO_PTR | MY_WME |
+                                             ME_FATALERROR));
+        if (!entry->value)
+	  return 1;
+      }
+    }
+    if (type == STRING_RESULT)
+    {
+      length--;					// Fix length change above
+      entry->value[length]= 0;			// Store end \0
+    }
+    memcpy(entry->value,ptr,length);
+    if (type == DECIMAL_RESULT)
+      ((my_decimal*)entry->value)->fix_buffer_pointer();
+    entry->length= length;
+    entry->collation.set(cs, dv);
+    entry->unsigned_flag= unsigned_arg;
+  }
+  entry->type=type;
+  return 0;
+}

=== added file 'drizzled/functions/update_hash.h'
--- drizzled/functions/update_hash.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/update_hash.h	2008-10-30 21:40:56 +0000
@@ -0,0 +1,38 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_UPDATE_HASH_H
+#define DRIZZLED_FUNCTIONS_UPDATE_HASH_H
+
+#include <drizzled/functions/func.h> 
+
+bool
+update_hash(
+  user_var_entry *entry, 
+  bool set_null, 
+  void *ptr, 
+  uint32_t length,
+  Item_result type, 
+  const CHARSET_INFO * const cs, 
+  Derivation dv,
+  bool unsigned_arg
+  );
+
+
+#endif /* DRIZZLED_FUNCTIONS_UPDATE_HASH_H */

=== added file 'drizzled/functions/user_var_as_out_param.cc'
--- drizzled/functions/user_var_as_out_param.cc	1970-01-01 00:00:00 +0000
+++ drizzled/functions/user_var_as_out_param.cc	2008-10-30 21:40:56 +0000
@@ -0,0 +1,88 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include CSTDINT_H
+#include <drizzled/functions/user_var_as_out_param.h>
+
+bool Item_user_var_as_out_param::fix_fields(Session *session, Item **ref)
+{
+  assert(fixed == 0);
+  if (Item::fix_fields(session, ref) ||
+      !(entry= get_variable(&session->user_vars, name, 1)))
+    return true;
+  entry->type= STRING_RESULT;
+  /*
+    Let us set the same collation which is used for loading
+    of fields in LOAD DATA INFILE.
+    (Since Item_user_var_as_out_param is used only there).
+  */
+  entry->collation.set(session->variables.collation_database);
+  entry->update_query_id= session->query_id;
+  return false;
+}
+
+void Item_user_var_as_out_param::set_null_value(const CHARSET_INFO * const cs)
+{
+  ::update_hash(entry, true, 0, 0, STRING_RESULT, cs,
+                DERIVATION_IMPLICIT, 0 /* unsigned_arg */);
+}
+
+
+void Item_user_var_as_out_param::set_value(const char *str, uint32_t length,
+                                           const CHARSET_INFO * const cs)
+{
+  ::update_hash(entry, false, (void*)str, length, STRING_RESULT, cs,
+                DERIVATION_IMPLICIT, 0 /* unsigned_arg */);
+}
+
+double Item_user_var_as_out_param::val_real()
+{
+  assert(0);
+  return 0.0;
+}
+
+
+int64_t Item_user_var_as_out_param::val_int()
+{
+  assert(0);
+  return 0;
+}
+
+
+String* Item_user_var_as_out_param::val_str(String *str __attribute__((unused)))
+{
+  assert(0);
+  return 0;
+}
+
+my_decimal* Item_user_var_as_out_param::val_decimal(my_decimal *decimal_buffer __attribute__((unused)))
+{
+  assert(0);
+  return 0;
+}
+
+
+void Item_user_var_as_out_param::print(String *str,
+                                       enum_query_type query_type __attribute__((unused)))
+{
+  str->append('@');
+  str->append(name.str,name.length);
+}
+

=== added file 'drizzled/functions/user_var_as_out_param.h'
--- drizzled/functions/user_var_as_out_param.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/user_var_as_out_param.h	2008-10-30 21:40:56 +0000
@@ -0,0 +1,53 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_USER_VAR_AS_OUT_PARAM_H
+#define DRIZZLED_FUNCTIONS_USER_VAR_AS_OUT_PARAM_H
+
+#include <drizzled/functions/func.h> 
+
+/*
+  This item represents user variable used as out parameter (e.g in LOAD DATA),
+  and it is supposed to be used only for this purprose. So it is simplified
+  a lot. Actually you should never obtain its value.
+
+  The only two reasons for this thing being an Item is possibility to store it
+  in List<Item> and desire to place this code somewhere near other functions
+  working with user variables.
+*/
+class Item_user_var_as_out_param :public Item
+{
+  LEX_STRING name;
+  user_var_entry *entry;
+public:
+  Item_user_var_as_out_param(LEX_STRING a) : name(a) {}
+  /* We should return something different from FIELD_ITEM here */
+  enum Type type() const { return STRING_ITEM;}
+  double val_real();
+  int64_t val_int();
+  String *val_str(String *str);
+  my_decimal *val_decimal(my_decimal *decimal_buffer);
+  /* fix_fields() binds variable name with its entry structure */
+  bool fix_fields(Session *session, Item **ref);
+  virtual void print(String *str, enum_query_type query_type);
+  void set_null_value(const CHARSET_INFO * const cs);
+  void set_value(const char *str, uint32_t length, const CHARSET_INFO * const cs);
+};
+
+#endif /* DRIZZLED_FUNCTIONS_USER_VAR_AS_OUT_PARAM_H */

=== modified file 'drizzled/global.h'
--- drizzled/global.h	2008-11-01 08:40:42 +0000
+++ drizzled/global.h	2008-11-02 08:50:37 +0000
@@ -36,7 +36,6 @@
 
 # include CSTDINT_H
 # include CINTTYPES_H
-# include CMATH_H
 # include <cstdio>
 # include <cstdlib>
 # include <cstddef>

=== modified file 'drizzled/handler.cc'
--- drizzled/handler.cc	2008-10-30 12:27:25 +0000
+++ drizzled/handler.cc	2008-11-02 03:17:55 +0000
@@ -26,6 +26,11 @@
 #include <drizzled/data_home.h>
 #include <drizzled/probes.h>
 #include <drizzled/sql_parse.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 /*
   While we have legacy_db_type, we have this array to

=== modified file 'drizzled/item.cc'
--- drizzled/item.cc	2008-10-23 02:48:56 +0000
+++ drizzled/item.cc	2008-11-02 03:17:55 +0000
@@ -17,6 +17,11 @@
 #include <drizzled/server_includes.h>
 #include <drizzled/sql_select.h>
 #include <drizzled/error.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 const String my_null_string("NULL", 4, default_charset_info);
 
@@ -37,6 +42,11 @@
   return &real_traits_instance;
 }
 
+int64_t Hybrid_type_traits::val_int(Hybrid_type *val,
+                                    bool) const
+{
+  return (int64_t) rint(val->real);
+}
 
 my_decimal *
 Hybrid_type_traits::val_decimal(Hybrid_type *val,
@@ -1979,6 +1989,20 @@
 }
 
 
+int64_t Item_float::val_int()
+{
+  assert(fixed == 1);
+  if (value <= (double) INT64_MIN)
+  {
+     return INT64_MIN;
+  }
+  else if (value >= (double) (uint64_t) INT64_MAX)
+  {
+    return INT64_MAX;
+  }
+  return (int64_t) rint(value);
+}
+
 my_decimal *Item_float::val_decimal(my_decimal *decimal_value)
 {
   // following assert is redundant, because fixed=1 assigned in constructor

=== modified file 'drizzled/item.h'
--- drizzled/item.h	2008-10-27 23:19:48 +0000
+++ drizzled/item.h	2008-11-02 03:17:55 +0000
@@ -168,8 +168,7 @@
   { val->real/= uint64_t2double(u); }
 
   virtual int64_t val_int(Hybrid_type *val,
-                           bool unsigned_flag __attribute__((unused))) const
-  { return (int64_t) rint(val->real); }
+                          bool unsigned_flag) const;
   virtual double val_real(Hybrid_type *val) const { return val->real; }
   virtual my_decimal *val_decimal(Hybrid_type *val, my_decimal *buf) const;
   virtual String *val_str(Hybrid_type *val, String *buf, uint8_t decimals) const;
@@ -1517,19 +1516,7 @@
   enum Type type() const { return REAL_ITEM; }
   enum_field_types field_type() const { return DRIZZLE_TYPE_DOUBLE; }
   double val_real() { assert(fixed == 1); return value; }
-  int64_t val_int()
-  {
-    assert(fixed == 1);
-    if (value <= (double) INT64_MIN)
-    {
-       return INT64_MIN;
-    }
-    else if (value >= (double) (uint64_t) INT64_MAX)
-    {
-      return INT64_MAX;
-    }
-    return (int64_t) rint(value);
-  }
+  int64_t val_int();
   String *val_str(String*);
   my_decimal *val_decimal(my_decimal *);
   bool basic_const_item() const { return 1; }

=== modified file 'drizzled/item_cmpfunc.cc'
--- drizzled/item_cmpfunc.cc	2008-10-23 03:41:40 +0000
+++ drizzled/item_cmpfunc.cc	2008-11-02 03:17:55 +0000
@@ -24,6 +24,11 @@
 #include <drizzled/server_includes.h>
 #include <drizzled/sql_select.h>
 #include <drizzled/error.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 static bool convert_constant_item(Session *, Item_field *, Item **);
 

=== modified file 'drizzled/item_func.cc'
--- drizzled/item_func.cc	2008-10-30 02:40:49 +0000
+++ drizzled/item_func.cc	2008-10-30 21:40:56 +0000
@@ -150,201 +150,6 @@
   return copy_or_same(session);
 }
 
-/*
-  When a user variable is updated (in a SET command or a query like
-  SELECT @a:= ).
-*/
-
-bool Item_func_set_user_var::fix_fields(Session *session, Item **ref)
-{
-  assert(fixed == 0);
-  /* fix_fields will call Item_func_set_user_var::fix_length_and_dec */
-  if (Item_func::fix_fields(session, ref) ||
-      !(entry= get_variable(&session->user_vars, name, 1)))
-    return true;
-  /* 
-     Remember the last query which updated it, this way a query can later know
-     if this variable is a constant item in the query (it is if update_query_id
-     is different from query_id).
-  */
-  entry->update_query_id= session->query_id;
-  /*
-    As it is wrong and confusing to associate any 
-    character set with NULL, @a should be latin2
-    after this query sequence:
-
-      SET @a=_latin2'string';
-      SET @a=NULL;
-
-    I.e. the second query should not change the charset
-    to the current default value, but should keep the 
-    original value assigned during the first query.
-    In order to do it, we don't copy charset
-    from the argument if the argument is NULL
-    and the variable has previously been initialized.
-  */
-  null_item= (args[0]->type() == NULL_ITEM);
-  if (!entry->collation.collation || !null_item)
-    entry->collation.set(args[0]->collation.collation, DERIVATION_IMPLICIT);
-  collation.set(entry->collation.collation, DERIVATION_IMPLICIT);
-  cached_result_type= args[0]->result_type();
-  return false;
-}
-
-
-void
-Item_func_set_user_var::fix_length_and_dec()
-{
-  maybe_null=args[0]->maybe_null;
-  max_length=args[0]->max_length;
-  decimals=args[0]->decimals;
-  collation.set(args[0]->collation.collation, DERIVATION_IMPLICIT);
-}
-
-
-/*
-  Mark field in read_map
-
-  NOTES
-    This is used by filesort to register used fields in a a temporary
-    column read set or to register used fields in a view
-*/
-
-bool Item_func_set_user_var::register_field_in_read_map(unsigned char *arg)
-{
-  if (result_field)
-  {
-    Table *table= (Table *) arg;
-    if (result_field->table == table || !table)
-      bitmap_set_bit(result_field->table->read_set, result_field->field_index);
-    if (result_field->vcol_info && result_field->vcol_info->expr_item)
-      return result_field->vcol_info->
-               expr_item->walk(&Item::register_field_in_read_map, 1, arg);
-  }
-  return 0;
-}
-
-
-/*
-  Mark field in bitmap supplied as *arg
-
-*/
-
-bool Item_func_set_user_var::register_field_in_bitmap(unsigned char *arg)
-{
-  MY_BITMAP *bitmap = (MY_BITMAP *) arg;
-  assert(bitmap);
-  if (result_field)
-  {
-    bitmap_set_bit(bitmap, result_field->field_index);
-  }
-  return 0;
-}
-
-
-/**
-  Set value to user variable.
-
-  @param entry          pointer to structure representing variable
-  @param set_null       should we set NULL value ?
-  @param ptr            pointer to buffer with new value
-  @param length         length of new value
-  @param type           type of new value
-  @param cs             charset info for new value
-  @param dv             derivation for new value
-  @param unsigned_arg   indiates if a value of type INT_RESULT is unsigned
-
-  @note Sets error and fatal error if allocation fails.
-
-  @retval
-    false   success
-  @retval
-    true    failure
-*/
-
-#define extra_size sizeof(double)
-
-static bool
-update_hash(user_var_entry *entry, bool set_null, void *ptr, uint32_t length,
-            Item_result type, const CHARSET_INFO * const cs, Derivation dv,
-            bool unsigned_arg)
-{
-  if (set_null)
-  {
-    char *pos= (char*) entry+ ALIGN_SIZE(sizeof(user_var_entry));
-    if (entry->value && entry->value != pos)
-      free(entry->value);
-    entry->value= 0;
-    entry->length= 0;
-  }
-  else
-  {
-    if (type == STRING_RESULT)
-      length++;					// Store strings with end \0
-    if (length <= extra_size)
-    {
-      /* Save value in value struct */
-      char *pos= (char*) entry+ ALIGN_SIZE(sizeof(user_var_entry));
-      if (entry->value != pos)
-      {
-	if (entry->value)
-	  free(entry->value);
-	entry->value=pos;
-      }
-    }
-    else
-    {
-      /* Allocate variable */
-      if (entry->length != length)
-      {
-	char *pos= (char*) entry+ ALIGN_SIZE(sizeof(user_var_entry));
-	if (entry->value == pos)
-	  entry->value=0;
-        entry->value= (char*) my_realloc(entry->value, length,
-                                         MYF(MY_ALLOW_ZERO_PTR | MY_WME |
-                                             ME_FATALERROR));
-        if (!entry->value)
-	  return 1;
-      }
-    }
-    if (type == STRING_RESULT)
-    {
-      length--;					// Fix length change above
-      entry->value[length]= 0;			// Store end \0
-    }
-    memcpy(entry->value,ptr,length);
-    if (type == DECIMAL_RESULT)
-      ((my_decimal*)entry->value)->fix_buffer_pointer();
-    entry->length= length;
-    entry->collation.set(cs, dv);
-    entry->unsigned_flag= unsigned_arg;
-  }
-  entry->type=type;
-  return 0;
-}
-
-
-bool
-Item_func_set_user_var::update_hash(void *ptr, uint32_t length,
-                                    Item_result res_type,
-                                    const CHARSET_INFO * const cs, Derivation dv,
-                                    bool unsigned_arg)
-{
-  /*
-    If we set a variable explicitely to NULL then keep the old
-    result type of the variable
-  */
-  if ((null_value= args[0]->null_value) && null_item)
-    res_type= entry->type;                      // Don't change type of item
-  if (::update_hash(entry, (null_value= args[0]->null_value),
-                    ptr, length, res_type, cs, dv, unsigned_arg))
-  {
-    null_value= 1;
-    return 1;
-  }
-  return 0;
-}
-
 
 /** Get the value of a variable as a double. */
 
@@ -462,428 +267,3 @@
   }
   return(val);
 }
-
-/**
-  This functions is invoked on SET \@variable or
-  \@variable:= expression.
-
-  Evaluate (and check expression), store results.
-
-  @note
-    For now it always return OK. All problem with value evaluating
-    will be caught by session->is_error() check in sql_set_variables().
-
-  @retval
-    false OK.
-*/
-
-bool
-Item_func_set_user_var::check(bool use_result_field)
-{
-  if (use_result_field && !result_field)
-    use_result_field= false;
-
-  switch (cached_result_type) {
-  case REAL_RESULT:
-  {
-    save_result.vreal= use_result_field ? result_field->val_real() :
-                        args[0]->val_real();
-    break;
-  }
-  case INT_RESULT:
-  {
-    save_result.vint= use_result_field ? result_field->val_int() :
-                       args[0]->val_int();
-    unsigned_flag= use_result_field ? ((Field_num*)result_field)->unsigned_flag:
-                    args[0]->unsigned_flag;
-    break;
-  }
-  case STRING_RESULT:
-  {
-    save_result.vstr= use_result_field ? result_field->val_str(&value) :
-                       args[0]->val_str(&value);
-    break;
-  }
-  case DECIMAL_RESULT:
-  {
-    save_result.vdec= use_result_field ?
-                       result_field->val_decimal(&decimal_buff) :
-                       args[0]->val_decimal(&decimal_buff);
-    break;
-  }
-  case ROW_RESULT:
-  default:
-    // This case should never be chosen
-    assert(0);
-    break;
-  }
-  return(false);
-}
-
-
-/**
-  This functions is invoked on
-  SET \@variable or \@variable:= expression.
-
-  @note
-    We have to store the expression as such in the variable, independent of
-    the value method used by the user
-
-  @retval
-    0	OK
-  @retval
-    1	EOM Error
-
-*/
-
-bool
-Item_func_set_user_var::update()
-{
-  bool res= false;
-
-  switch (cached_result_type) {
-  case REAL_RESULT:
-  {
-    res= update_hash((void*) &save_result.vreal,sizeof(save_result.vreal),
-		     REAL_RESULT, &my_charset_bin, DERIVATION_IMPLICIT, 0);
-    break;
-  }
-  case INT_RESULT:
-  {
-    res= update_hash((void*) &save_result.vint, sizeof(save_result.vint),
-                     INT_RESULT, &my_charset_bin, DERIVATION_IMPLICIT,
-                     unsigned_flag);
-    break;
-  }
-  case STRING_RESULT:
-  {
-    if (!save_result.vstr)					// Null value
-      res= update_hash((void*) 0, 0, STRING_RESULT, &my_charset_bin,
-		       DERIVATION_IMPLICIT, 0);
-    else
-      res= update_hash((void*) save_result.vstr->ptr(),
-		       save_result.vstr->length(), STRING_RESULT,
-		       save_result.vstr->charset(),
-		       DERIVATION_IMPLICIT, 0);
-    break;
-  }
-  case DECIMAL_RESULT:
-  {
-    if (!save_result.vdec)					// Null value
-      res= update_hash((void*) 0, 0, DECIMAL_RESULT, &my_charset_bin,
-                       DERIVATION_IMPLICIT, 0);
-    else
-      res= update_hash((void*) save_result.vdec,
-                       sizeof(my_decimal), DECIMAL_RESULT,
-                       &my_charset_bin, DERIVATION_IMPLICIT, 0);
-    break;
-  }
-  case ROW_RESULT:
-  default:
-    // This case should never be chosen
-    assert(0);
-    break;
-  }
-  return(res);
-}
-
-
-double Item_func_set_user_var::val_real()
-{
-  assert(fixed == 1);
-  check(0);
-  update();					// Store expression
-  return entry->val_real(&null_value);
-}
-
-int64_t Item_func_set_user_var::val_int()
-{
-  assert(fixed == 1);
-  check(0);
-  update();					// Store expression
-  return entry->val_int(&null_value);
-}
-
-String *Item_func_set_user_var::val_str(String *str)
-{
-  assert(fixed == 1);
-  check(0);
-  update();					// Store expression
-  return entry->val_str(&null_value, str, decimals);
-}
-
-
-my_decimal *Item_func_set_user_var::val_decimal(my_decimal *val)
-{
-  assert(fixed == 1);
-  check(0);
-  update();					// Store expression
-  return entry->val_decimal(&null_value, val);
-}
-
-
-double Item_func_set_user_var::val_result()
-{
-  assert(fixed == 1);
-  check(true);
-  update();					// Store expression
-  return entry->val_real(&null_value);
-}
-
-int64_t Item_func_set_user_var::val_int_result()
-{
-  assert(fixed == 1);
-  check(true);
-  update();					// Store expression
-  return entry->val_int(&null_value);
-}
-
-String *Item_func_set_user_var::str_result(String *str)
-{
-  assert(fixed == 1);
-  check(true);
-  update();					// Store expression
-  return entry->val_str(&null_value, str, decimals);
-}
-
-
-my_decimal *Item_func_set_user_var::val_decimal_result(my_decimal *val)
-{
-  assert(fixed == 1);
-  check(true);
-  update();					// Store expression
-  return entry->val_decimal(&null_value, val);
-}
-
-
-void Item_func_set_user_var::print(String *str, enum_query_type query_type)
-{
-  str->append(STRING_WITH_LEN("(@"));
-  str->append(name.str, name.length);
-  str->append(STRING_WITH_LEN(":="));
-  args[0]->print(str, query_type);
-  str->append(')');
-}
-
-
-void Item_func_set_user_var::print_as_stmt(String *str,
-                                           enum_query_type query_type)
-{
-  str->append(STRING_WITH_LEN("set @"));
-  str->append(name.str, name.length);
-  str->append(STRING_WITH_LEN(":="));
-  args[0]->print(str, query_type);
-  str->append(')');
-}
-
-bool Item_func_set_user_var::send(Protocol *protocol, String *str_arg)
-{
-  if (result_field)
-  {
-    check(1);
-    update();
-    return protocol->store(result_field);
-  }
-  return Item::send(protocol, str_arg);
-}
-
-void Item_func_set_user_var::make_field(Send_field *tmp_field)
-{
-  if (result_field)
-  {
-    result_field->make_field(tmp_field);
-    assert(tmp_field->table_name != 0);
-    if (Item::name)
-      tmp_field->col_name=Item::name;               // Use user supplied name
-  }
-  else
-    Item::make_field(tmp_field);
-}
-
-
-/*
-  Save the value of a user variable into a field
-
-  SYNOPSIS
-    save_in_field()
-      field           target field to save the value to
-      no_conversion   flag indicating whether conversions are allowed
-
-  DESCRIPTION
-    Save the function value into a field and update the user variable
-    accordingly. If a result field is defined and the target field doesn't
-    coincide with it then the value from the result field will be used as
-    the new value of the user variable.
-
-    The reason to have this method rather than simply using the result
-    field in the val_xxx() methods is that the value from the result field
-    not always can be used when the result field is defined.
-    Let's consider the following cases:
-    1) when filling a tmp table the result field is defined but the value of it
-    is undefined because it has to be produced yet. Thus we can't use it.
-    2) on execution of an INSERT ... SELECT statement the save_in_field()
-    function will be called to fill the data in the new record. If the SELECT
-    part uses a tmp table then the result field is defined and should be
-    used in order to get the correct result.
-
-    The difference between the SET_USER_VAR function and regular functions
-    like CONCAT is that the Item_func objects for the regular functions are
-    replaced by Item_field objects after the values of these functions have
-    been stored in a tmp table. Yet an object of the Item_field class cannot
-    be used to update a user variable.
-    Due to this we have to handle the result field in a special way here and
-    in the Item_func_set_user_var::send() function.
-
-  RETURN VALUES
-    false       Ok
-    true        Error
-*/
-
-int Item_func_set_user_var::save_in_field(Field *field, bool no_conversions,
-                                          bool can_use_result_field)
-{
-  bool use_result_field= (!can_use_result_field ? 0 :
-                          (result_field && result_field != field));
-  int error;
-
-  /* Update the value of the user variable */
-  check(use_result_field);
-  update();
-
-  if (result_type() == STRING_RESULT ||
-      (result_type() == REAL_RESULT && field->result_type() == STRING_RESULT))
-  {
-    String *result;
-    const CHARSET_INFO * const cs= collation.collation;
-    char buff[MAX_FIELD_WIDTH];		// Alloc buffer for small columns
-    str_value.set_quick(buff, sizeof(buff), cs);
-    result= entry->val_str(&null_value, &str_value, decimals);
-
-    if (null_value)
-    {
-      str_value.set_quick(0, 0, cs);
-      return set_field_to_null_with_conversions(field, no_conversions);
-    }
-
-    /* NOTE: If null_value == false, "result" must be not NULL.  */
-
-    field->set_notnull();
-    error=field->store(result->ptr(),result->length(),cs);
-    str_value.set_quick(0, 0, cs);
-  }
-  else if (result_type() == REAL_RESULT)
-  {
-    double nr= entry->val_real(&null_value);
-    if (null_value)
-      return set_field_to_null(field);
-    field->set_notnull();
-    error=field->store(nr);
-  }
-  else if (result_type() == DECIMAL_RESULT)
-  {
-    my_decimal decimal_value;
-    my_decimal *val= entry->val_decimal(&null_value, &decimal_value);
-    if (null_value)
-      return set_field_to_null(field);
-    field->set_notnull();
-    error=field->store_decimal(val);
-  }
-  else
-  {
-    int64_t nr= entry->val_int(&null_value);
-    if (null_value)
-      return set_field_to_null_with_conversions(field, no_conversions);
-    field->set_notnull();
-    error=field->store(nr, unsigned_flag);
-  }
-  return error;
-}
-
-
-bool Item_user_var_as_out_param::fix_fields(Session *session, Item **ref)
-{
-  assert(fixed == 0);
-  if (Item::fix_fields(session, ref) ||
-      !(entry= get_variable(&session->user_vars, name, 1)))
-    return true;
-  entry->type= STRING_RESULT;
-  /*
-    Let us set the same collation which is used for loading
-    of fields in LOAD DATA INFILE.
-    (Since Item_user_var_as_out_param is used only there).
-  */
-  entry->collation.set(session->variables.collation_database);
-  entry->update_query_id= session->query_id;
-  return false;
-}
-
-
-void Item_user_var_as_out_param::set_null_value(const CHARSET_INFO * const cs)
-{
-  ::update_hash(entry, true, 0, 0, STRING_RESULT, cs,
-                DERIVATION_IMPLICIT, 0 /* unsigned_arg */);
-}
-
-
-void Item_user_var_as_out_param::set_value(const char *str, uint32_t length,
-                                           const CHARSET_INFO * const cs)
-{
-  ::update_hash(entry, false, (void*)str, length, STRING_RESULT, cs,
-                DERIVATION_IMPLICIT, 0 /* unsigned_arg */);
-}
-
-
-double Item_user_var_as_out_param::val_real()
-{
-  assert(0);
-  return 0.0;
-}
-
-
-int64_t Item_user_var_as_out_param::val_int()
-{
-  assert(0);
-  return 0;
-}
-
-
-String* Item_user_var_as_out_param::val_str(String *str __attribute__((unused)))
-{
-  assert(0);
-  return 0;
-}
-
-
-my_decimal* Item_user_var_as_out_param::val_decimal(my_decimal *decimal_buffer __attribute__((unused)))
-{
-  assert(0);
-  return 0;
-}
-
-
-void Item_user_var_as_out_param::print(String *str,
-                                       enum_query_type query_type __attribute__((unused)))
-{
-  str->append('@');
-  str->append(name.str,name.length);
-}
-
-/***************************************************************************
-  System variables
-****************************************************************************/
-
-/**
-  Return value of an system variable base[.name] as a constant item.
-
-  @param session			Thread handler
-  @param var_type		global / session
-  @param name		        Name of base or system variable
-  @param component		Component.
-
-  @note
-    If component.str = 0 then the variable name is in 'name'
-
-  @return
-    - 0  : error
-    - #  : constant item
-*/

=== modified file 'drizzled/item_func.h'
--- drizzled/item_func.h	2008-10-29 02:36:17 +0000
+++ drizzled/item_func.h	2008-10-30 21:40:56 +0000
@@ -63,6 +63,7 @@
 #include <drizzled/functions/real.h>
 #include <drizzled/functions/rollup_const.h>
 #include <drizzled/functions/row_count.h>
+#include <drizzled/functions/set_user_var.h>
 #include <drizzled/functions/dec.h>
 #include <drizzled/functions/int_val.h>
 #include <drizzled/functions/acos.h>
@@ -88,95 +89,10 @@
 #include <drizzled/functions/sign.h>
 #include <drizzled/functions/signed.h>
 #include <drizzled/functions/tan.h>
+#include <drizzled/functions/update_hash.h>
+#include <drizzled/functions/user_var_as_out_param.h>
 #include <drizzled/functions/unsigned.h>
 
-/* Handling of user definable variables */
-
-class user_var_entry;
-
-class Item_func_set_user_var :public Item_func
-{
-  enum Item_result cached_result_type;
-  user_var_entry *entry;
-  char buffer[MAX_FIELD_WIDTH];
-  String value;
-  my_decimal decimal_buff;
-  bool null_item;
-  union
-  {
-    int64_t vint;
-    double vreal;
-    String *vstr;
-    my_decimal *vdec;
-  } save_result;
-
-public:
-  LEX_STRING name; // keep it public
-  Item_func_set_user_var(LEX_STRING a,Item *b)
-    :Item_func(b), cached_result_type(INT_RESULT), name(a)
-  {}
-  enum Functype functype() const { return SUSERVAR_FUNC; }
-  double val_real();
-  int64_t val_int();
-  String *val_str(String *str);
-  my_decimal *val_decimal(my_decimal *);
-  double val_result();
-  int64_t val_int_result();
-  String *str_result(String *str);
-  my_decimal *val_decimal_result(my_decimal *);
-  bool update_hash(void *ptr, uint32_t length, enum Item_result type,
-  		   const CHARSET_INFO * const cs, Derivation dv, bool unsigned_arg);
-  bool send(Protocol *protocol, String *str_arg);
-  void make_field(Send_field *tmp_field);
-  bool check(bool use_result_field);
-  bool update();
-  enum Item_result result_type () const { return cached_result_type; }
-  bool fix_fields(Session *session, Item **ref);
-  void fix_length_and_dec();
-  virtual void print(String *str, enum_query_type query_type);
-  void print_as_stmt(String *str, enum_query_type query_type);
-  const char *func_name() const { return "set_user_var"; }
-  int save_in_field(Field *field, bool no_conversions,
-                    bool can_use_result_field);
-  int save_in_field(Field *field, bool no_conversions)
-  {
-    return save_in_field(field, no_conversions, 1);
-  }
-  void save_org_in_field(Field *field) { (void)save_in_field(field, 1, 0); }
-  bool register_field_in_read_map(unsigned char *arg);
-  bool register_field_in_bitmap(unsigned char *arg);
-};
-
-
-/*
-  This item represents user variable used as out parameter (e.g in LOAD DATA),
-  and it is supposed to be used only for this purprose. So it is simplified
-  a lot. Actually you should never obtain its value.
-
-  The only two reasons for this thing being an Item is possibility to store it
-  in List<Item> and desire to place this code somewhere near other functions
-  working with user variables.
-*/
-class Item_user_var_as_out_param :public Item
-{
-  LEX_STRING name;
-  user_var_entry *entry;
-public:
-  Item_user_var_as_out_param(LEX_STRING a) : name(a) {}
-  /* We should return something different from FIELD_ITEM here */
-  enum Type type() const { return STRING_ITEM;}
-  double val_real();
-  int64_t val_int();
-  String *val_str(String *str);
-  my_decimal *val_decimal(my_decimal *decimal_buffer);
-  /* fix_fields() binds variable name with its entry structure */
-  bool fix_fields(Session *session, Item **ref);
-  virtual void print(String *str, enum_query_type query_type);
-  void set_null_value(const CHARSET_INFO * const cs);
-  void set_value(const char *str, uint32_t length, const CHARSET_INFO * const cs);
-};
-
-
 /* For type casts */
 
 enum Cast_target

=== modified file 'drizzled/item_strfunc.cc'
--- drizzled/item_strfunc.cc	2008-10-30 02:40:49 +0000
+++ drizzled/item_strfunc.cc	2008-11-02 03:17:55 +0000
@@ -35,6 +35,11 @@
 
 // For soundex_map
 #include <mysys/my_static.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 using namespace std;
 

=== modified file 'drizzled/item_sum.cc'
--- drizzled/item_sum.cc	2008-10-29 21:21:57 +0000
+++ drizzled/item_sum.cc	2008-11-02 03:17:55 +0000
@@ -23,6 +23,11 @@
 #include <drizzled/server_includes.h>
 #include <drizzled/sql_select.h>
 #include <drizzled/error.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 extern my_decimal decimal_zero;
 
@@ -541,6 +546,13 @@
 }
 
 
+int64_t Item_sum_num::val_int()
+{
+  assert(fixed == 1);
+  return (int64_t) rint(val_real());             /* Real as default */
+}
+
+
 my_decimal *Item_sum_num::val_decimal(my_decimal *decimal_value)
 {
   return val_decimal_from_real(decimal_value);
@@ -1269,6 +1281,12 @@
 }
 
 
+int64_t Item_sum_avg::val_int()
+{
+  return (int64_t) rint(val_real());
+}
+
+
 my_decimal *Item_sum_avg::val_decimal(my_decimal *val)
 {
   my_decimal sum_buff, cnt;
@@ -1491,6 +1509,13 @@
 }
 
 
+int64_t Item_sum_variance::val_int()
+{
+  /* can't be fix_fields()ed */
+  return (int64_t) rint(val_real());
+}
+
+
 my_decimal *Item_sum_variance::val_decimal(my_decimal *dec_buf)
 {
   assert(fixed == 1);
@@ -2407,6 +2432,13 @@
 }
 
 
+int64_t Item_variance_field::val_int()
+{
+  /* can't be fix_fields()ed */
+  return (int64_t) rint(val_real());
+}
+
+
 double Item_variance_field::val_real()
 {
   // fix_fields() never calls for this Item

=== modified file 'drizzled/item_sum.h'
--- drizzled/item_sum.h	2008-10-20 04:28:21 +0000
+++ drizzled/item_sum.h	2008-11-02 03:17:55 +0000
@@ -398,11 +398,7 @@
   Item_sum_num(Session *session, Item_sum_num *item) 
     :Item_sum(session, item),is_evaluated(item->is_evaluated) {}
   bool fix_fields(Session *, Item **);
-  int64_t val_int()
-  {
-    assert(fixed == 1);
-    return (int64_t) rint(val_real());             /* Real as default */
-  }
+  int64_t val_int();
   String *val_str(String*str);
   my_decimal *val_decimal(my_decimal *);
   void reset_field();
@@ -676,7 +672,7 @@
   bool add();
   double val_real();
   // In SPs we might force the "wrong" type with select into a declare variable
-  int64_t val_int() { return (int64_t) rint(val_real()); }
+  int64_t val_int();
   my_decimal *val_decimal(my_decimal *);
   String *val_str(String *str);
   void reset_field();
@@ -709,8 +705,7 @@
   Item_variance_field(Item_sum_variance *item);
   enum Type type() const {return FIELD_VARIANCE_ITEM; }
   double val_real();
-  int64_t val_int()
-  { /* can't be fix_fields()ed */ return (int64_t) rint(val_real()); }
+  int64_t val_int();
   String *val_str(String *str)
   { return val_string_from_real(str); }
   my_decimal *val_decimal(my_decimal *dec_buf)
@@ -769,6 +764,7 @@
   void clear();
   bool add();
   double val_real();
+  int64_t val_int();
   my_decimal *val_decimal(my_decimal *);
   void reset_field();
   void update_field();

=== modified file 'drizzled/log.cc'
--- drizzled/log.cc	2008-10-29 21:21:57 +0000
+++ drizzled/log.cc	2008-11-02 03:17:55 +0000
@@ -37,6 +37,7 @@
 #include <drizzled/gettext.h>
 #include <drizzled/data_home.h>
 
+
 /* max size of the log message */
 #define MY_OFF_T_UNDEF (~(my_off_t)0UL)
 

=== modified file 'drizzled/opt_range.cc'
--- drizzled/opt_range.cc	2008-10-23 03:41:40 +0000
+++ drizzled/opt_range.cc	2008-11-02 03:17:55 +0000
@@ -106,6 +106,11 @@
 #include <drizzled/server_includes.h>
 #include <drizzled/sql_select.h>
 #include <drizzled/error.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 /*
   Convert double value to #rows. Currently this does floor(), and we

=== modified file 'drizzled/serialize/Makefile.am'
--- drizzled/serialize/Makefile.am	2008-10-31 22:23:13 +0000
+++ drizzled/serialize/Makefile.am	2008-11-01 01:25:04 +0000
@@ -17,8 +17,8 @@
 
 LDADD = libserialize.la ${PROTOBUF_LIBS}
 
-AM_CXXFLAGS = ${AM_CXXFLAGS} -Wno-error
 AM_CPPFLAGS = ${PROTOBUF_CPPFLAGS}
+libserialize_la_CXXFLAGS =
 
 TESTS_ENVIRONMENT = sh
 TESTS = check_length.sh
@@ -57,21 +57,28 @@
 DEFS= @DEFS@
 
 binlog_reader_SOURCES = binlog_reader.cc binary_log.cc
+binlog_reader_CXXFLAGS = 
 
 binlog_writer_SOURCES = binlog_writer.cc binary_log.cc
+binlog_writer_CXXFLAGS = 
 
 schema_reader_SOURCES =  schema_reader.cc
+schema_reader_CXXFLAGS =
 
 table_reader_SOURCES =  table_reader.cc
+table_reader_CXXFLAGS =
 
 table_writer_SOURCES =  table_writer.cc
+table_writer_CXXFLAGS =
 
 master_list_writer_SOURCES =  master_list_writer.cc
+master_list_writer_CXXFLAGS =
 
 master_list_reader_SOURCES =  master_list_reader.cc
+master_list_reader_CXXFLAGS =
 
 length_SOURCES = length.cc
-length_CXXFLAGS = ${AM_CXXFLAGS} -fexceptions
+length_CXXFLAGS = -fexceptions
 
 EXTRA_DIST = schema.proto table.proto binary_log.proto master_list.proto
 BUILT_SOURCES = schema.pb.h \

=== modified file 'drizzled/server_includes.h'
--- drizzled/server_includes.h	2008-10-29 21:21:57 +0000
+++ drizzled/server_includes.h	2008-11-02 03:17:55 +0000
@@ -562,7 +562,7 @@
                  const char **errmsg);
 
 /* mysqld.cc */
-extern void MYSQLerror(const char*);
+extern void DRIZZLEerror(const char*);
 void refresh_status(Session *session);
 bool mysql_rm_tmp_tables(void);
 void handle_connection_in_main_thread(Session *session);

=== modified file 'drizzled/set_var.cc'
--- drizzled/set_var.cc	2008-10-29 21:21:57 +0000
+++ drizzled/set_var.cc	2008-10-30 21:37:46 +0000
@@ -494,16 +494,6 @@
 static sys_var_const_str        sys_hostname(&vars, "hostname", glob_hostname);
 
 static sys_var_const_str_ptr    sys_repl_report_host(&vars, "report_host", &report_host);
-static sys_var_const_str_ptr    sys_repl_report_user(&vars, "report_user", &report_user);
-static sys_var_const_str_ptr    sys_repl_report_password(&vars, "report_password", &report_password);
-
-static unsigned char *slave_get_report_port(Session *session)
-{
-  session->sys_var_tmp.long_value= report_port;
-  return (unsigned char*) &session->sys_var_tmp.long_value;
-}
-
-static sys_var_readonly    sys_repl_report_port(&vars, "report_port", OPT_GLOBAL, SHOW_INT, slave_get_report_port);
 
 sys_var_session_bool  sys_keep_files_on_create(&vars, "keep_files_on_create", 
                                            &SV::keep_files_on_create);

=== modified file 'drizzled/slave.cc'
--- drizzled/slave.cc	2008-10-30 12:27:25 +0000
+++ drizzled/slave.cc	2008-10-31 05:09:50 +0000
@@ -1110,10 +1110,6 @@
   if (!report_host)
     return(0);
   report_host_len= strlen(report_host);
-  if (report_user)
-    report_user_len= strlen(report_user);
-  if (report_password)
-    report_password_len= strlen(report_password);
   /* 30 is a good safety margin */
   if (report_host_len + report_user_len + report_password_len + 30 >
       sizeof(buf))
@@ -1121,8 +1117,8 @@
 
   int4store(pos, server_id); pos+= 4;
   pos= net_store_data(pos, (unsigned char*) report_host, report_host_len);
-  pos= net_store_data(pos, (unsigned char*) report_user, report_user_len);
-  pos= net_store_data(pos, (unsigned char*) report_password, report_password_len);
+  pos= net_store_data(pos, NULL, report_user_len);
+  pos= net_store_data(pos, NULL, report_password_len);
   int2store(pos, (uint16_t) report_port); pos+= 2;
   int4store(pos, 0);    pos+= 4;
   /* The master will fill in master_id */

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2008-10-30 05:50:30 +0000
+++ drizzled/sql_select.cc	2008-11-02 03:17:55 +0000
@@ -33,6 +33,11 @@
 #include <drizzled/util/test.h>
 #include <drizzled/nested_join.h>
 #include <drizzled/probes.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 const char *join_type_str[]={ "UNKNOWN","system","const","eq_ref","ref",
 			      "MAYBE_REF","ALL","range","index",

=== modified file 'drizzled/uniques.cc'
--- drizzled/uniques.cc	2008-10-06 06:47:29 +0000
+++ drizzled/uniques.cc	2008-11-02 03:17:55 +0000
@@ -31,7 +31,12 @@
 */
 
 #include <drizzled/server_includes.h>
-#include "sql_sort.h"
+#include <drizzled/sql_sort.h>
+#include CMATH_H
+
+#if defined(CMATH_NAMESPACE)
+using namespace CMATH_NAMESPACE;
+#endif
 
 
 int unique_write_to_file(unsigned char* key,

=== modified file 'm4/alloca.m4'
--- m4/alloca.m4	2008-08-12 21:13:01 +0000
+++ m4/alloca.m4	2008-11-02 03:17:55 +0000
@@ -46,20 +46,6 @@
    ALLOCA=alloca.o
    AC_DEFINE(C_ALLOCA, 1)
  
- AC_CACHE_CHECK(whether alloca needs Cray hooks, ac_cv_os_cray,
- [AC_EGREP_CPP(webecray,
- [#if defined(CRAY) && ! defined(CRAY2)
- webecray
- #else
- wenotbecray
- #endif
- ], ac_cv_os_cray=yes, ac_cv_os_cray=no)])
- if test "$ac_cv_os_cray" = "yes"; then
- for ac_func in _getb67 GETB67 getb67; do
-   AC_CHECK_FUNC($ac_func, [AC_DEFINE_UNQUOTED(CRAY_STACKSEG_END, $ac_func)
-   break])
- done
- fi
  fi
  AC_SUBST(ALLOCA)dnl
 else

=== modified file 'm4/cxx_cmath.m4'
--- m4/cxx_cmath.m4	2008-10-08 00:51:53 +0000
+++ m4/cxx_cmath.m4	2008-11-02 03:17:55 +0000
@@ -30,6 +30,9 @@
    fi
    AC_DEFINE_UNQUOTED(CMATH_H,$ac_cv_cxx_cmath,
                       [the location of <cmath>])
-   AC_DEFINE_UNQUOTED(CMATH_NAMESPACE,$ac_cv_cxx_cmath_namespace,
-                      [the namespace of C99 math extensions])
+   if test "x$ac_cv_cxx_cmath_namespace" != "x"
+   then
+     AC_DEFINE_UNQUOTED(CMATH_NAMESPACE,$ac_cv_cxx_cmath_namespace,
+                        [the namespace of C99 math extensions])
+   fi
 ])

=== modified file 'm4/misc.m4'
--- m4/misc.m4	2008-11-01 00:33:11 +0000
+++ m4/misc.m4	2008-11-02 03:17:55 +0000
@@ -317,18 +317,6 @@
 fi
 ])
 
-AC_DEFUN([DRIZZLE_HAVE_FIONREAD],
-[AC_MSG_CHECKING(for FIONREAD in sys/ioctl.h)
-AC_CACHE_VAL(mysql_cv_fionread_in_ioctl,
-[AC_TRY_COMPILE([#include <sys/types.h>
-#include <sys/ioctl.h>], [int x = FIONREAD;],
-  mysql_cv_fionread_in_ioctl=yes,mysql_cv_fionread_in_ioctl=no)])
-AC_MSG_RESULT($mysql_cv_fionread_in_ioctl)
-if test "$mysql_cv_fionread_in_ioctl" = "yes"; then   
-AC_DEFINE([FIONREAD_IN_SYS_IOCTL], [1], [Do we have FIONREAD])
-fi
-])
-
 AC_DEFUN([DRIZZLE_HAVE_TIOCSTAT],
 [AC_MSG_CHECKING(for TIOCSTAT in sys/ioctl.h)
 AC_CACHE_VAL(mysql_cv_tiocstat_in_ioctl,
@@ -342,75 +330,6 @@
 fi
 ])
 
-AC_DEFUN([DRIZZLE_STRUCT_DIRENT_D_INO],
-[AC_REQUIRE([AC_HEADER_DIRENT])
-AC_MSG_CHECKING(if struct dirent has a d_ino member)
-AC_CACHE_VAL(mysql_cv_dirent_has_dino,
-[AC_TRY_COMPILE([
-#include <stdio.h>
-#include <sys/types.h>
-#ifdef HAVE_UNISTD_H
-# include <unistd.h>
-#endif /* HAVE_UNISTD_H */
-#if defined(HAVE_DIRENT_H)
-# include <dirent.h>
-#else
-# define dirent direct
-# ifdef HAVE_SYS_NDIR_H
-#  include <sys/ndir.h>
-# endif /* SYSNDIR */
-# ifdef HAVE_SYS_DIR_H
-#  include <sys/dir.h>
-# endif /* SYSDIR */
-# ifdef HAVE_NDIR_H
-#  include <ndir.h>
-# endif
-#endif /* HAVE_DIRENT_H */
-],[
-struct dirent d; int z; z = d.d_ino;
-], mysql_cv_dirent_has_dino=yes, mysql_cv_dirent_has_dino=no)])
-AC_MSG_RESULT($mysql_cv_dirent_has_dino)
-if test "$mysql_cv_dirent_has_dino" = "yes"; then
-AC_DEFINE(STRUCT_DIRENT_HAS_D_INO, [1],
-          [d_ino member present in struct dirent])
-fi
-])
-
-AC_DEFUN([DRIZZLE_STRUCT_DIRENT_D_NAMLEN],
-[AC_REQUIRE([AC_HEADER_DIRENT])
-AC_MSG_CHECKING(if struct dirent has a d_namlen member)
-AC_CACHE_VAL(mysql_cv_dirent_has_dnamlen,
-[AC_TRY_COMPILE([
-#include <stdio.h>
-#include <sys/types.h>
-#ifdef HAVE_UNISTD_H
-# include <unistd.h>
-#endif /* HAVE_UNISTD_H */
-#if defined(HAVE_DIRENT_H)
-# include <dirent.h>
-#else
-# define dirent direct
-# ifdef HAVE_SYS_NDIR_H
-#  include <sys/ndir.h>
-# endif /* SYSNDIR */
-# ifdef HAVE_SYS_DIR_H
-#  include <sys/dir.h>
-# endif /* SYSDIR */
-# ifdef HAVE_NDIR_H
-#  include <ndir.h>
-# endif
-#endif /* HAVE_DIRENT_H */
-],[
-struct dirent d; int z; z = (int)d.d_namlen;
-], mysql_cv_dirent_has_dnamlen=yes, mysql_cv_dirent_has_dnamlen=no)])
-AC_MSG_RESULT($mysql_cv_dirent_has_dnamlen)
-if test "$mysql_cv_dirent_has_dnamlen" = "yes"; then
-AC_DEFINE(STRUCT_DIRENT_HAS_D_NAMLEN, [1],
-          [d_namlen member present in struct dirent])
-fi
-])
-
-
 AC_DEFUN([DRIZZLE_TYPE_SIGHANDLER],
 [AC_MSG_CHECKING([whether signal handlers are of type void])
 AC_CACHE_VAL(mysql_cv_void_sighandler,
@@ -430,25 +349,6 @@
 fi
 ])
 
-AC_DEFUN([DRIZZLE_CXX_BOOL],
-[
-AC_REQUIRE([AC_PROG_CXX])
-AC_MSG_CHECKING(if ${CXX} supports bool types)
-AC_CACHE_VAL(mysql_cv_have_bool,
-[
-AC_LANG_SAVE
-AC_LANG_CPLUSPLUS
-AC_TRY_COMPILE(,[bool b = true;],
-mysql_cv_have_bool=yes,
-mysql_cv_have_bool=no)
-AC_LANG_RESTORE
-])
-AC_MSG_RESULT($mysql_cv_have_bool)
-if test "$mysql_cv_have_bool" = yes; then
-AC_DEFINE([HAVE_BOOL], [1], [bool is not defined by all C++ compilators])
-fi
-])dnl
-
 AC_DEFUN([DRIZZLE_STACK_DIRECTION],
  [AC_CACHE_CHECK(stack direction for C alloca, ac_cv_c_stack_direction,
  [AC_TRY_RUN([#include <stdlib.h>

=== modified file 'm4/readline.m4'
--- m4/readline.m4	2008-08-12 21:13:01 +0000
+++ m4/readline.m4	2008-11-02 03:17:55 +0000
@@ -39,41 +39,3 @@
     )
 ])
 
-dnl
-dnl check for availability of multibyte characters and functions
-dnl (Based on BASH_CHECK_MULTIBYTE in aclocal.m4 of readline-5.0)
-dnl
-AC_DEFUN([DRIZZLE_CHECK_MULTIBYTE],
-[
-AC_CHECK_HEADERS(wctype.h)
-AC_CHECK_HEADERS(wchar.h)
-AC_CHECK_HEADERS(langinfo.h)
-
-AC_CHECK_FUNC(mbsrtowcs, AC_DEFINE([HAVE_MBSRTOWCS],[],[Define if you have mbsrtowcs]))
-AC_CHECK_FUNC(mbrtowc, AC_DEFINE([HAVE_MBRTOWC],[],[Define if you have mbrtowc]))
-AC_CHECK_FUNC(mbrlen, AC_DEFINE([HAVE_MBRLEN],[],[Define if you have mbrlen]))
-AC_CHECK_FUNC(wctomb, AC_DEFINE([HAVE_WCTOMB],[],[Define if you have wctomb]))
-AC_CHECK_FUNC(wcwidth, AC_DEFINE([HAVE_WCWIDTH],[],[Define if you have wcwidth]))
-AC_CHECK_FUNC(wcsdup, AC_DEFINE([HAVE_WCSDUP],[],[Define if you check wcsdup]))
-
-AC_CACHE_CHECK([for mbstate_t], mysql_cv_have_mbstate_t,
-[AC_TRY_COMPILE([
-#include <wchar.h>], [
-  mbstate_t ps;
-  mbstate_t *psp;
-  psp = (mbstate_t *)0;
-], mysql_cv_have_mbstate_t=yes,  mysql_cv_have_mbstate_t=no)])
-if test $mysql_cv_have_mbstate_t = yes; then
-        AC_DEFINE([HAVE_MBSTATE_T],[],[Define if mysql_cv_have_mbstate_t=yes])
-fi
-
-AC_CACHE_CHECK([for nl_langinfo and CODESET], mysql_cv_langinfo_codeset,
-[AC_TRY_LINK(
-[#include <langinfo.h>],
-[char* cs = nl_langinfo(CODESET);],
-mysql_cv_langinfo_codeset=yes, mysql_cv_langinfo_codeset=no)])
-if test $mysql_cv_langinfo_codeset = yes; then
-  AC_DEFINE([HAVE_LANGINFO_CODESET],[],[Define if mysql_cv_langinfo_codeset=yes])
-fi
-
-])

=== modified file 'tests/test-run.pl'
--- tests/test-run.pl	2008-10-09 20:07:49 +0000
+++ tests/test-run.pl	2008-10-30 21:37:46 +0000
@@ -2546,9 +2546,6 @@
     mtr_add_arg($args, "%s--relay-log=%s/log/slave%s-relay-bin", $prefix,
                 $opt_vardir, $sidx);
     mtr_add_arg($args, "%s--report-host=127.0.0.1", $prefix);
-    mtr_add_arg($args, "%s--report-port=%d", $prefix,
-                $mysqld->{'port'});
-#    mtr_add_arg($args, "%s--report-user=root", $prefix);
     mtr_add_arg($args, "%s--loose-skip-innodb", $prefix);
     mtr_add_arg($args, "%s--skip-slave-start", $prefix);
 

